#include "fun.h"
void printM(int **m,int n,const char *sf)
{int *l=new int[n]; AutoFree<int> AF_l(l); char str[512];
 memset(l,0,n*sizeof(int));
 for(int i=0;i<n;i++)for(int j=0;j<n;j++)l[i]=Max((int)l[i], ((int)sprintf(str,"%d",m[i][j]),(int)strlen(str)));
 for(int i=0;i<n;i++,printf("\n"))for(int j=0;j<n;j++)printf("%*hd ",l[i],m[i][j]);
 if(sf)
 {
  FILE *f=fopen(sf,"w");
  if(f)
  {
   fprintf(f,"%d\n",n);
   for(int i=0;i<n;i++,fprintf(f,"\n"))for(int j=0;j<n;j++)fprintf(f,"%*d ",l[i],m[i][j]);
   fclose(f);
  }
 }
}

void printM(short int **m,short int n,const char *sf)
{int *l=new int[n]; AutoFree<int> AF_l(l); char str[512];
 memset(l,0,n*sizeof(int));
 for(int i=0;i<n;i++)for(int j=0;j<n;j++)l[i]=Max((int)l[i], ((int)sprintf(str,"%d",m[i][j]),(int)strlen(str)));
 for(int i=0;i<n;i++,printf("\n"))for(int j=0;j<n;j++)printf("%*hd ",l[i],m[i][j]);
 if(sf)
 {
  FILE *f=fopen(sf,"w");
  if(f)
  {
   fprintf(f,"%hd\n",n);
   for(int i=0;i<n;i++,fprintf(f,"\n"))for(int j=0;j<n;j++)fprintf(f,"%*hd ",l[i],m[i][j]);
   fclose(f);
  }
 }
}

void printM(char **m,int n,const char *sf)
{int *l=new int[n]; AutoFree<int> AF_l(l); char str[512];
 memset(l,0,n*sizeof(int));
 for(int i=0;i<n;i++)for(int j=0;j<n;j++)l[i]=Max((int)l[i], ((int)sprintf(str,"%d",m[i][j]),(int)strlen(str)));
 for(int i=0;i<n;i++,printf("\n"))for(int j=0;j<n;j++)printf("%*d ",l[i],m[i][j]);
 if(sf)
 {
  FILE *f=fopen(sf,"w");
  if(f)
  {
   fprintf(f,"%d\n",n);
   for(int i=0;i<n;i++,fprintf(f,"\n"))for(int j=0;j<n;j++)fprintf(f,"%*d ",l[i],m[i][j]);
   fclose(f);
  }
 }
}

void printMN(int **m,int n)
{int *l=new int[n]; AutoFree<int> AF_l(l); char str[512];
 memset(l,0,n*sizeof(int));
 for(int i=0;i<n;i++)for(int j=0;j<n;j++)l[i]=Max((int)l[i], ((int)sprintf(str,"%d",m[i][j]),(int)strlen(str)));
 for(int i=0;i<n;i++,printf("\n"))for(int j=0;j<n;j++)printf("%*hd ",l[i],m[i][j]);
}

void printMN(char **m_,int n)
{int *l=new int[n+1]; AutoFree<int> AF_l(l); char str[512]; int i,j;
 char **m=allocate_2D_Array(n+1,n+1,1,1);
 for(i=1;i<=n;i++)m[i][0]=m[0][i]=i-1;
 for(i=0;i<n;i++)for(j=0;j<n;j++)m[i+1][j+1]=m_[i][j];
 memset(l,0,n*sizeof(int));
 for(int i=0;i<=n;i++)for(int j=0;j<=n;j++)l[i]=Max((int)l[i], ((int)sprintf(str,"%d",m[i][j]),(int)strlen(str)));
 for(int i=0;i<=n;i++,printf("\n"))
 {
  if(i==1)
  {for(int j=0;j<=n;j++)printf("%*s%s ",l[i],"-",(j==0?":":""));printf("\n");}
   for(int j=0;j<=n;j++)printf("%*d%s ",l[i],m[i][j],(j==0?":":""));
 }
 delete[] (char*)m;
}

int check_latin(int **m,int n,int *i_,int *j_)
{
 char *set=new char[n];
  for(int i=0;i<n;i++)
  {
   memset(set,0,n);
   for(int j=0;j<n;j++)
   {
    if(set[m[i][j]])
    {if(i_)*i_=i;if(j_)*j_=j;delete[] set; return 0;}
     set[m[i][j]]=1;
   }
  }
  for(int i=0;i<n;i++)
  {
   memset(set,0,n);
   for(int j=0;j<n;j++)
   {
     if(set[m[j][i]])
     {if(i_)*i_=j;if(j_)*j_=i;delete[] set; return 0;}
     set[m[j][i]]=1;
   }
  }
 delete[] set; set=NULL;
 return 1;
}
int check_latin(short int **m,int n,short int *i_,short int *j_)
{
 char *set=new char[n];
  for(int i=0;i<n;i++)
  {
   memset(set,0,n);
   for(int j=0;j<n;j++)
   {
    if(set[m[i][j]])
    {if(i_)*i_=i;if(j_)*j_=j;delete[] set; return 0;}
     set[m[i][j]]=1;
   }
  }
  for(int i=0;i<n;i++)
  {
   memset(set,0,n);
   for(int j=0;j<n;j++)
   {
     if(set[m[j][i]])
     {if(i_)*i_=j;if(j_)*j_=i;delete[] set; return 0;}
     set[m[j][i]]=1;
   }
  }
 delete[] set; set=NULL;
 return 1;
}

//#define BACK(i) list[i][0]
#define NEXT(i) list[i][0]
#define NUM(i) list[i][1]

void ShowGroups(const char *str, int (*list)[2],int n)
{int i,j; char *set=new char[n]; memset(set,0,n);
 printf("%s\n",str);
 for(i=0;i<n;i++)if(NUM(i)>=0&&!set[i])
 {
  printf("(");
  for(j=i;NEXT(j)!=i&&NEXT(j)!=j;j=NEXT(j))
  {//if(BACK(NEXT(j))!=j)printf("error(%d)\n",j);
   printf("%d ",j);set[j]=1;if(0){printf(" (i=%d j=%d NEXT(j)=%d) ",i,j,NEXT(j));getchar();}}
  if(NEXT(j)!=i&&NEXT(j)!=j)
  {//if(BACK(NEXT(j))!=j)printf("error(%d)\n",j);
   printf("%d",j);set[j]=1;}
  printf(")\n");
 }
 delete[] set;set=NULL;
}


int MakeQPrime(int **m,int n,int nSub)
{int i,j; int v;
 {int k,l;int t;
  if(n%nSub!=0){printf("MakeQ: n=%d nSub=%d\n",n,nSub);getchar(); exit(-1); return -1;}
  int **m1=(int**)allocate_2D_Array(n/nSub,n/nSub,sizeof(int),1);
  int **m2=(int**)allocate_2D_Array(nSub,nSub,sizeof(int),1);
  MakeQ(m1,n/nSub);
  MakeQ(m2,nSub);
  for(i=0;i<n/nSub;i++)for(j=0;j<n/nSub;j++)
  {
   for(k=0;k<nSub;k++)for(l=0;l<nSub;l++)
    m[i*nSub+k][j*nSub+l]=m2[k][l]+m1[i][j]*nSub;
  }
  i=rand()%(n/nSub-1);
  j=rand()%(n/nSub);
  k=rand()%(nSub);
 printM("before:",m,n);
  {
   for(l=0;l<nSub;l++)
   {v=m[i*nSub+k][j*nSub+l];m[i*nSub+k][j*nSub+l]=m[(i+1)*nSub+k][j*nSub+l];m[(i+1)*nSub+k][j*nSub+l]=v;}
  }
 printM("before:",m,n);
  //printM("m not prime:",m,n);
  for(int I=0;I<20;I++)
  {
   i=rand()%n;j=rand()%n;
   for(k=0;k<n;k++)for(l=0;l<n;l++)
    if(m[k][l]==i)m[k][l]=-1;
   for(k=0;k<n;k++)for(l=0;l<n;l++)
    if(m[k][l]==j)m[k][l]=i; else if(m[k][l]==-1)m[k][l]=j;
   for(k=0;k<n;k++)
   {t=m[k][i];m[k][i]=m[k][j];m[k][j]=t;}
   for(k=0;k<n;k++)
   {t=m[i][k];m[i][k]=m[j][k];m[j][k]=t;}
  }
  delete[] (char*)m1; m1=NULL; delete[] (char*)m2; m2=NULL;
  return 0;
 }
}

int MakeQ(int **m,int n,int nSub)
{int i=-1,j=-1,k=-1,NStep=0; int x,N,v; 
 if(nSub>0)
 {int k,l;int t;
  if(n%nSub!=0){printf("MakeQ: n=%d nSub=%d\n",n,nSub);getchar(); exit(-1); return -1;}
  int **m1=(int**)allocate_2D_Array(n/nSub,n/nSub,sizeof(int),1);
  int **m2=(int**)allocate_2D_Array(nSub,nSub,sizeof(int),1);
  MakeQ(m1,n/nSub);
  MakeQ(m2,nSub);
  for(i=0;i<n/nSub;i++)for(j=0;j<n/nSub;j++)
  {
   for(k=0;k<nSub;k++)for(l=0;l<nSub;l++)
    m[i*nSub+k][j*nSub+l]=m2[k][l]+m1[i][j]*nSub;
  }
  //printM("m not prime:",m,n);
  for(int I=0;I<20;I++)
  {
   i=rand()%n;j=rand()%n;
   for(k=0;k<n;k++)for(l=0;l<n;l++)
    if(m[k][l]==i)m[k][l]=-1;
   for(k=0;k<n;k++)for(l=0;l<n;l++)
    if(m[k][l]==j)m[k][l]=i; else if(m[k][l]==-1)m[k][l]=j;
   for(k=0;k<n;k++)
   {t=m[k][i];m[k][i]=m[k][j];m[k][j]=t;}
   for(k=0;k<n;k++)
   {t=m[i][k];m[i][k]=m[j][k];m[j][k]=t;}
  }
  delete[] (char*)m1; m1=NULL; delete[] (char*)m2; m2=NULL;
  return 0;
 }
 char *used=new char[n];
 for(NStep=1;;NStep++)
 {
  for(i=0;i<n;i++)for(j=0;j<n;j++)m[i][j]=0;
  for(i=0;i<n;i++)
  {
   for(j=0;j<n;j++)
   {
    memset(used,0,n);
    for(k=0;k<i;k++)used[m[k][j]]=1;
    for(k=0;k<j;k++)used[m[i][k]]=1;
    for(N=0,k=0;k<n;k++)if(!used[k])N++;
    if(N==0)
     goto lc;
    x=rand()%N;
    for(v=0,k=0;k<n;k++)if(!used[k])
    {
     if(x==v)
     {m[i][j]=k;used[k]=1;if(0)printM("M=",m,n);break;}
     v++;
    }
   }
  }
  i=i;
  if(i==n&&j==n)
   break;
  lc:;
 }
delete[] used; used=NULL;
return NStep;
}

int CheckPrimeEasy(int **m,int n,int *c)
{int N=0;
 if(n==4)
 {int c_[4],U[4]={0}; int i1, j1,j2, i,j,k,l; if(c==NULL)c=c_;
  c[0]=0;
  for(i1=1;i1<n;i1++)
  {
   U[i1]=1;
   for(j1=1;j1<n;j1++)if(U[j1]==0)//i1!=j1)
   {
    U[j1]=1;
    for(j2=1;j2<n;j2++)if(U[j2]==0)//j2!=j1&&i1!=j2)
    {
     c[0]=0;c[i1]=0;
     c[j1]=1;c[j2]=1;
     for(i=0;i<n;i++)for(j=0;j<n;j++)if(c[i]==c[j])
     {
      for(k=0;k<n;k++)for(l=0;l<n;l++)if(c[k]==c[l])
      {
       if(c[m[i][k]]!=c[m[j][l]])
        goto lc1;
      }
     }
     return 0;
     lc1:;
    }
    U[j1]=0;
   }
   U[i1]=0;
  }
  return 1;
 }
 else if(n==6)
 {int c_[6],U[6]={0}; int i1,i2, j1,j2,j3, k1,k2,i,j,k,l; if(c==NULL)c=c_;
  c[0]=0;
  for(i1=1;i1<n;i1++)
  {
   U[i1]=1;
   for(j1=1;j1<n;j1++)if(!U[j1])//i1!=j1)
   {
    U[j1]=1;
    for(j2=1;j2<n;j2++)if(!U[j2])//j2!=j1&&i1!=j2)
    {
     U[j2]=1;
     for(k1=1;k1<n;k1++)if(!U[k1])//k1!=i1&&k1!=j1&&k1!=j2)
     {
      U[k1]=1;
      for(k2=1;k2<n;k2++)if(!U[k2])//k2!=k1&&k2!=i1&&k2!=j1&&k2!=j2)
      {
       c[0]=0;c[i1]=0;
       c[j1]=1;c[j2]=1;
       c[k1]=2;c[k2]=2;
       for(i=0;i<n;i++)for(j=0;j<n;j++)if(c[i]==c[j])
       {
        for(k=0;k<n;k++)for(l=0;l<n;l++)if(c[k]==c[l])
        {
         if(c[m[i][k]]!=c[m[j][l]])
          goto lc2;
        }
       }
       return 0;
       lc2:;
      }
      U[k1]=0;
     }
     U[j2]=0;
    }
    U[j1]=0;
   }
   U[i1]=0;
  }
  for(i1=1;i1<n;i1++)
  {
   U[i1]=1;
   for(i2=1;i2<n;i2++)if(!U[i2])//i2!=i1)
   {
    U[i2]=1;
    for(j1=1;j1<n;j1++)if(!U[j1])//j1!=i1&&j1!=i2)
    {
     U[j1]=1;
     for(j2=1;j2<n;j2++)if(!U[j2])//j2!=j1&&j2!=i1&&j2!=i2)
     {
      U[j2]=1;
      for(j3=1;j3<n;j3++)if(!U[j3])//j3!=j2&&j3!=j1&&j3!=i1&&j3!=i2)
      {
       c[0]=0;c[i1]=0; c[i2]=0;
       c[j1]=1;c[j2]=1;c[j3]=1;
       for(i=0;i<6;i++)for(j=0;j<n;j++)if(c[i]==c[j])
       {
        for(k=0;k<6;k++)for(l=0;l<n;l++)if(c[k]==c[l])
        {
         if(c[m[i][k]]!=c[m[j][l]])
          goto lc3;
        }
       }
       return 0;
       lc3:;
      }
      U[j2]=0;
     }
     U[j1]=0;
    }
    U[i2]=0;
   }
   U[i1]=0;
  }
  return 1;
 }
 else if(n==8)
 {int c_[8],U[8]={0}; int i1,i2,i3, j1,j2,j3,j4, k1,k2, l1,l2, i,j,k,l; if(c==NULL)c=c_;
  c[0]=0;
  for(i1=1;i1<n;i1++)
  {
   U[i1]=1;
   for(j1=1;j1<n;j1++)if(!U[j1])//i1!=j1)
   {
    U[j1]=1;
    for(j2=1;j2<n;j2++)if(!U[j2])//j2!=j1&&i1!=j2)
    {
     U[j2]=1;
     for(k1=1;k1<n;k1++)if(!U[k1])//k1!=i1&&k1!=j1&&k1!=j2)
     {
      U[k1]=1;
      for(k2=1;k2<n;k2++)if(!U[k2])//k2!=k1&&k2!=i1&&k2!=j1&&k2!=j2)
      {
       U[k2]=1;
       for(l1=1;l1<n;l1++)if(!U[l1])//l1!=k1&&l1!=k2&&l1!=i1&&l1!=j1&&l1!=j2)
       {
        U[l1]=1;
        for(l2=1;l2<n;l2++)if(!U[l2])//l2!=l1&&l2!=k1&&l2!=k2&&l2!=k1&&l2!=i1&&l2!=j1&&k2!=j2)
        {
         c[0]=0;c[i1]=0;
         c[j1]=1;c[j2]=1;
         c[k1]=2;c[k2]=2;
         c[l1]=3;c[l2]=3;
         for(i=0;i<n;i++)for(j=0;j<n;j++)if(c[i]==c[j])
         {
          for(k=0;k<n;k++)for(l=0;l<n;l++)if(c[k]==c[l])
          {
           if(c[m[i][k]]!=c[m[j][l]])
            goto lc4;
          }
         }
         return 0;
         lc4:;
        }
        U[l1]=0;
       }
       U[k2]=0;
      }
      U[k1]=0;
     }
     U[j2]=0;
    }
    U[j1]=0;
   }
   U[i1]=0;
  }
  for(i1=1;i1<n;i1++)
  {
   U[i1]=1;
   for(i2=1;i2<n;i2++)if(!U[i2])//i2!=i1)
   {
    U[i2]=1;
    for(i3=1;i3<n;i3++)if(!U[i3])//i3!=i2&&i2!=i1)
    {
     U[i3]=1;
     for(j1=1;j1<n;j1++)if(!U[j1])//j1!=i3&&j1!=i1&&j1!=i2)
     {
      U[j1]=1;
      for(j2=1;j2<n;j2++)if(!U[j2])//j2!=j1&&j2!=i1&&j2!=i2&&j2!=i3)
      {
       U[j2]=1;
       for(j3=1;j3<n;j3++)if(!U[j3])//j3!=j2&&j3!=j1&&j3!=i1&&j3!=i2&&j3!=i3)
       {
        U[j3]=1;
        for(j4=1;j4<n;j4++)if(!U[j4])//j4!=j3&&j4!=j2&&j4!=j1&&j4!=i1&&j4!=i2&&j4!=i3)
        {
         c[0]=0;c[i1]=0; c[i2]=0;c[i3]=0;
         c[j1]=1;c[j2]=1;c[j3]=1;c[j4]=1;
         for(i=0;i<n;i++)for(j=0;j<n;j++)if(c[i]==c[j])
         {
          for(k=0;k<n;k++)for(l=0;l<n;l++)if(c[k]==c[l])
          {
           if(c[m[i][k]]!=c[m[j][l]])
            goto lc5;
          }
         }
         return 0;
         lc5:;
        }
        U[j3]=0;
       }
       U[j2]=0;
      }
      U[j1]=0;
     }
     U[i3]=0;
    }
    U[i2]=0;
   }
   U[i1]=0;
  }
  return 1;
 }
 else
 {printf("CheckPrimeEasy(): not implemented for n=%d\n",n);exit(-1);}
 return N;
}

int CheckNotPrime(int **r,int **gr,int ngr,int n)
{int *num=new int[n]; int i,j,k,c; memset(num,-1,sizeof(int)*n);
 for(i=0;i<ngr;i++)
  for(j=0;j<gr[i][0];j++)
  {
   if(gr[i][j+1]<0||gr[i][j+1]>=n)return -1;
   if(num[gr[i][j+1]]>=0)return -2;
   num[gr[i][j+1]]=i;
  }
 for(i=0;i<n;i++)if(num[i]<0){{printf("\n");for(int I=0;I<ngr;I++,printf("\n"))for(int J=1;J<=gr[I][0];J++)printf("%d ",gr[I][J]);}return -3;}
 for(i=0;i<ngr;i++)
 {
 // igr=r[gr[i][1]][gr[i][2]];
  for(j=1;j<=gr[i][0];j++)for(k=1;k<=gr[i][0];k++)for(c=0;c<n;c++)if(num[r[gr[i][j]][c]]!=num[r[gr[i][k]][c]])
  {printf("num[r[gr[i][j]][c]]!=num[r[gr[i][k]][c]]: i=%d j=%d k=%d c=%d: %d!=%d r[%d][%d]!=r[%d][%d]\n",i,j,k,c,num[r[gr[i][j]][c]],num[r[gr[i][k]][c]],gr[i][j],c,gr[i][k],c); return -4;}
 }
delete[]num;
return 0;
}

//=============================================================================
#ifdef __MPI__
#include <mpi.h>
#endif
#include <stdio.h>
//#include <unistd.h>

int WaitStart();
int CheckStop();
int SetStop();
int SendStart(int i);
int SendStop(int i);
int SetMPIStart=0,SetMPIStop=0,MPIrank=0;
//---
int WaitStart()
{
#ifdef __MPI__
int rtn,rank;MPI_Request request; 
 //SetMPIStart=0;
 MPI_Comm_rank(MPI_COMM_WORLD, &rank); MPIrank=rank;
 rtn=MPI_Irecv(&SetMPIStart,1,MPI_INT,MPI_ANY_SOURCE,rank+100000/*MPI_ANY_TAG*/,MPI_COMM_WORLD,&request); rtn=rtn;
 while(SetMPIStart==0)
 {
  int flag=0;MPI_Status status;
  MPI_Iprobe(0,rank+100000,MPI_COMM_WORLD,&flag,&status);    
  sleep(1);
 }
 SetMPIStart=0;
 rtn=MPI_Irecv(&SetMPIStop,1,MPI_INT,MPI_ANY_SOURCE,rank+200000/*MPI_ANY_TAG*/,MPI_COMM_WORLD,&request); rtn=rtn;
#endif 
 return 0;
}
//---
int CheckStop()
{int rtn=0;
#ifdef __MPI__
int flag=0;MPI_Status status;
  MPI_Iprobe(0,MPIrank+200000,MPI_COMM_WORLD,&flag,&status);    
  if(SetMPIStop)
  {rtn=1;}
#endif
return rtn;
}
//---
int SetStop()
{
#ifdef __MPI__
 if(SetMPIStop)
 {SetMPIStop=0;}
 else
 {
  while(SetMPIStop==0)
  {
   int flag=0;MPI_Status status;
   MPI_Iprobe(0,MPIrank+200000,MPI_COMM_WORLD,&flag,&status);    flag=flag;status=status;
   sleep(1);
  }
  SetMPIStop=0;
 }
#endif
 return 0;
}
//---
int SendStart(int i)
{
#ifdef __MPI__
static int v=1;MPI_Request request; 
 MPI_Isend(&v,1,MPI_INT, i, i+100000, MPI_COMM_WORLD, &request);
#endif
 return 0;
}
//---
int SendStop(int i)
{
#ifdef __MPI__
static int v=1;MPI_Request request; 
 MPI_Isend(&v,1,MPI_INT, i, i+200000, MPI_COMM_WORLD, &request);
#endif
 return 0;
}
//---
//===================================================================================================
int CheckSimple1(int **r,int **rt,int n)
{int rtn=1,SetJSimple=1,NUsed=0,I,j,a,b,c,*Row0InStr=new int[n],*nj0=new int[n],**nab0; AutoFree<int> AF_Row0InStr(Row0InStr),AF_nj0(nj0); memset(nj0,0,n*sizeof(nj0[0]));
   nab0=(int**)allocate_2D_Array(n,n,sizeof(nab0[0][0]),1); AutoFree<int*> AF_nab0(nab0);
   for(a=0;a<n;a++)for(b=0;b<n;b++)if(r[a][b]==0)Row0InStr[a]=b;
    //printM("r:",r,n,NULL,1);//char stmp[30];
    for(j=1;j<n;j++)
    {
     SetJSimple=0;
     memset(nj0,0,n*sizeof(int));
     NUsed=0;
     for(c=0;c<n;c++)
     {
      a=r[0][c];b=r[j][c];
      nj0[r[b][Row0InStr[a]]]++;
      if(nj0[r[b][Row0InStr[a]]]==1)
      {
       NUsed++;
       if(NUsed>n/2)
       {SetJSimple=1;goto lej;}
      }
      //nab0[b][r[a][Row0InStr[a]]]++;
     }
     for(I=0;I<100;I++)
     {
      for(a=0;a<n;a++)if(nj0[a])for(b=0;b<n;b++)if(nj0[b]&&a!=b)
      {
       nj0[r[b][Row0InStr[a]]]++;
       if(nj0[r[b][Row0InStr[a]]]==1)
       {
        NUsed++;
        if(NUsed>n/2)
        {SetJSimple=1;goto lej;}
       }
      }
     }
     rtn=0;
     goto le;
     lej:;
    }//for(j=1;j<n;j++)
 le:;
  if(!SetJSimple)
  {int i,ni;
  // O1
    for(ni=1,i=1;i<n;i++)if(nj0[i])ni++;
    //fprintf(f,"group0 [%d elements] from CheckSimple1: 0 ",ni);
    //for(int i=1;i<n;i++)if(nj0[i])fprintf(f,"%d ",i); fprintf(f,"\n");
//   O2
  }
return rtn;
}

int MakePreclass0(int **r,int **rt,int n, int J, int *nSub)
{int rtn=1,SetJSimple=1,NUsed=0,I,j,a,b,c,*Row0InStr=new int[n],*nj0=new int[n]/*,**nab0*/; AutoFree<int> AF_Row0InStr(Row0InStr),AF_nj0(nj0); memset(nj0,0,n*sizeof(nj0[0]));
  // nab0=(int**)allocate_2D_Array(n,n,sizeof(nab0[0][0]),1); AutoFree<int*> AF_nab0(nab0);
   for(a=0;a<n;a++)for(b=0;b<n;b++)if(r[a][b]==0)Row0InStr[a]=b;
    //printM("r:",r,n,NULL,1);//char stmp[30];
//    for(j=1;j<n;j++)
 j=J; *nSub=n;
    {
     SetJSimple=0;
     memset(nj0,0,n*sizeof(int));
     NUsed=2;
     nj0[0]=1;nj0[J]=1;
     for(c=0;c<n;c++)
     {
      a=r[0][c];b=r[j][c];
      nj0[r[b][Row0InStr[a]]]++;
      if(nj0[r[b][Row0InStr[a]]]==1)
      {
       NUsed++;
       if(NUsed>n/2)
       {SetJSimple=1;return 1;}//goto lej;}
      }
      //nab0[b][r[a][Row0InStr[a]]]++;
     }
     for(I=0;I<100;I++)
     {
      for(a=0;a<n;a++)if(nj0[a])for(b=0;b<n;b++)if(nj0[b]&&a!=b)
      {
       nj0[r[b][Row0InStr[a]]]++;
       if(nj0[r[b][Row0InStr[a]]]==1)
       {
        NUsed++;
        if(NUsed>n/2)
        {SetJSimple=1;return 1;}//goto lej;}
       }
      }
     }
     rtn=0;
     goto le;
//     lej:;
    }//for(j=1;j<n;j++)
 le:;
  if(!SetJSimple)
  {int i,ni;
   //O1
    *nSub=1; nSub[1]=0;
    for(ni=1,i=1;i<n;i++)if(nj0[i]){nSub[++(*nSub)]=i; ni++;}
    //fprintf(f,"group0 [%d elements J=%d] from CheckSimple1: 0 ",ni,J);
    //for(int i=1;i<n;i++)if(nj0[i])fprintf(f,"%d ",i); fprintf(f,"\n");
    //for(int i=1;i<=*nSub;i++)fprintf(f,"%d ",nSub[i]); fprintf(f,"\n");
   //O2
  }
return rtn;
}

int MakeQRec(int n,int **r, int n_not_simple,int nI)
{int n0=8,I,i,j,k,o,p,nn,nnOld;
 //if(rand()%2)
 // for(nnOld=8,nn=8;nn<=n;nn=(nn*8<=n?nn*8:nn*2<=n?n:nn*2))
 // {n0=nn/nnOld;nnOld=nn;}
 // printf("n0=%d\n",n0);
 if(n<=8)
 {
  MakeQ(r,n,0);
  return 0;
 }
 int in0=rand()%3,**m=(int**)allocate_2D_Array(n,n,sizeof(int),1);
 if(in0==0)n0=2;else if(in0==1)n0=4;else in0=8;
 for(nn=n0;nn<=n;nn=(nn*8<=n?nn*8:nn*2<=n?n:nn*2))
 {
  if(nn==n0)
  {
   MakeQ(r,nn,0);
   if(nn!=n_not_simple)
   {
    for(I=0;I<nI;I++){i=rand()%nn; j=rand()%nn;for(k=0;k<nn;k++)swap(r[i][k],r[j][k]);}
    for(I=0;I<nI;I++){i=rand()%nn; j=rand()%nn;for(k=0;k<nn;k++)swap(r[k][i],r[k][j]);}
   }
  }
  else
  {int n2=nn/nnOld;
   //if(n2<=1||n2>8){printf("(464243) n2=%d\n",n2);exit(-1);}
   MakeQ(m,n2,0);
   for(i=0;i<nn;i+=nnOld)
    for(j=(i==0?nnOld:0);j<nn;j+=nnOld)
    {
     for(o=0;o<nnOld;o++)
      for(p=0;p<nnOld;p++)
       r[i+o][j+p]=r[o][p]+m[i/nnOld][j/nnOld]*nnOld;
    }
   i=0;j=0;
    {
     for(o=0;o<nnOld;o++)
      for(p=0;p<nnOld;p++)
       r[i+o][j+p]=r[o][p]+m[i/nnOld][j/nnOld]*nnOld;
    }
   if(nn!=n_not_simple)
   {
    for(I=0;I<nI;I++){i=rand()%nn; j=rand()%nn;for(k=0;k<nn;k++)swap(r[i][k],r[j][k]);}
    for(I=0;I<nI;I++){i=rand()%nn; j=rand()%nn;for(k=0;k<nn;k++)swap(r[k][i],r[k][j]);}
   }
  }
  nnOld=nn;
 }
 delete[] (char*)m; m=NULL;
 return 0;
}

void SwapR(int **r,int n,int i0,int i1)
{int i,j,v1;
#ifdef _DEBUG
 int **r1=(int**)allocate_2D_Array(n,n,sizeof(int),1);
 for(i=0;i<n;i++)for(j=0;j<n;j++)r1[i][j]=r[i][j];
#endif
 for(i=0;i<n;i++)
  swap(r[i][i0],r[i][i1]);
 for(i=0;i<n;i++)
  swap(r[i0][i],r[i1][i]);
 for(i=0;i<n;i++)
  for(j=0;j<n;j++)
  {
   if(r[i][j]==i0)
   {
    r[i][j]=i1;
    for(j++;j<n;j++)if(r[i][j]==i1)r[i][j]=i0;
   }
   else if(r[i][j]==i1)
   {
    r[i][j]=i0;
    for(j++;j<n;j++)if(r[i][j]==i0)r[i][j]=i1;
   }
  }
#ifdef _DEBUG
 for(i=0;i<n;i++)for(j=0;j<n;j++)
 {
  v1=(r1[i==i0?i1:i==i1?i0:i][j==i0?i1:j==i1?i0:j]);
  if((v1==i0?i1:v1==i1?i0:v1)!=r[i][j])
  //if(v1!=r[i][j])
  {i=i;}
 }
delete[] (char*)r1; r1=NULL;
#endif
}
